/* giFTui
 * Copyright (C) 2003 the giFTui team
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef __SIGNAL_H__
#define __SIGNAL_H__

#define GIFTUI_HANDLER_CB(arg) ((GiftuiHandlerCB_t) (arg))

typedef void (* GiftuiHandlerCB_t) (gpointer *);

void giftui_signal_init (void);
void giftui_signal_end (void);

void giftui_signal_register (const gchar *name, GiftuiHandlerCB_t handler, gpointer data);
void giftui_signal_unregister (const gchar *name, GiftuiHandlerCB_t handler, gpointer data);
void giftui_signal_unregister_by_handler (const gchar *name, GiftuiHandlerCB_t handler);
void giftui_signal_unregister_by_data (const gchar *name, gpointer data);

void giftui_signal_emit (const gchar *name);

#endif
